Magellan Linux

Diff of /trunk/initscripts/sysvinit/rc/rc

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/magellan-initscripts/etc/rc.d/init.d/rc revision 514 by niro, Fri Aug 17 22:07:29 2007 UTC trunk/initscripts/sysvinit/rc/rc revision 2304 by niro, Thu Jan 2 13:26:56 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2  # $Header: /home/cvsd/magellan-cvs/magellan-src/magellan-initscripts/etc/rc.d/init.d/rc,v 1.15 2007-08-17 22:07:29 niro Exp $  # $Id$
3    
4  source /etc/sysconfig/rc  source /etc/conf.d/rc
5  source $rc_functions  source ${rc_functions}
6    
7  # get mage version  # get mage version
8  MAGEVER="$(< /etc/mageversion)"  if [[ -f /etc/os-release ]]
9    then
10     MAGEVER="$(read_os_release version_id)"
11    elif [ -f /etc/mageversion ]
12    then
13     MAGEVER="$(< /etc/mageversion)"
14    else
15     MAGEVER="unkown"
16    fi
17    
18  # source kernel config if exists  # source kernel config if exists
19  [ -f /etc/conf.d/kernel ] && source /etc/conf.d/kernel  [ -f /etc/conf.d/kernel ] && source /etc/conf.d/kernel
20    
21  udev_version()  # override devicemanager helper functions
22  {  if [[ ${RC_DEVICEMANAGER} = udev ]] && [[ -f ${rc_base}/init.d/udev ]]
23   local version=0  then
24     source ${rc_base}/init.d/udev
  if [[ -x /sbin/udev ]]  
  then  
  version=$(/sbin/udev -V)  
  # We need it without a leading '0', else bash do the wrong thing  
  version=${version##0}  
  # Older udev's will print nothing  
  [[ -z ${version} ]] && version=0  
  elif [[ -x /sbin/udevd ]]  
  then  
  version=$(/sbin/udevd --version)  
  version=${version##0}  
  [[ -z ${version} ]] && version=0  
  fi  
   
  echo "${version}"  
 }  
   
 populate_udev()  
 {  
  local opts  
   
  # tell modprobe.sh to be verbose to $CONSOLE  
  echo CONSOLE=${CONSOLE} > /dev/.udev_populate  
   
  # populate /dev with devices already found by the kernel  
  if [ "$(kernel_version | sed 's:\.::g' | cut -d_ -f1)" -gt "2614" ]  
  then  
  echo -e ${COLOREDSTAR}"  Populating /dev with existing devices through uevents ..."  
  [[ $(udev_version) -ge "96" ]] && [[ ${RC_COLDPLUG} != yes ]] && opts="--attr-match=dev"  
  /sbin/udevtrigger ${opts}  
  evaluate_retval  
  else  
  echo -e ${COLOREDSTAR}"  Populating /dev with existing devices with udevstart ..."  
  /sbin/udevstart  
  evaluate_retval  
  fi  
   
  # loop until everything is finished  
  echo -e ${COLOREDSTAR}"  Letting udev process events ..."  
  /sbin/udevsettle --timeout=60  
  evaluate_retval  
   
  rm -f /dev/.udev_populate  
  return 0  
 }  
   
 seed_dev()  
 {  
  # seed /dev with some things that we know we need  
  echo -e ${COLOREDSTAR}"  Seeding /dev with needed nodes ..."  
  (  
  [ ! -c /dev/console ] && mknod /dev/console c 5 1  
  [ ! -c /dev/tty1 ] && mknod /dev/tty1 c 4 1  
  [ ! -c /dev/null ] && mknod /dev/null c 1 3  
   
  # copy over any persistant things  
  if [[ -d /lib/udev/devices ]]  
  then  
  cp --preserve=all --recursive --update /lib/udev/devices/* /dev 2>/dev/null  
  fi  
25    
26   # not provided by sysfs but needed  elif [[ ${RC_DEVICEMANAGER} = mdev ]] && [[ -f ${rc_base}/init.d/mdev ]]
27   ln -snf /proc/self/fd /dev/fd  then
28   ln -snf fd/0 /dev/stdin   source ${rc_base}/init.d/mdev
29   ln -snf fd/1 /dev/stdout  fi
  ln -snf fd/2 /dev/stderr  
  [[ -e /proc/kcore ]] && ln -snf /proc/kcore /dev/core  
   
  # create problematic directories  
  mkdir -p /dev/{pts,shm}  
  )  
  evaluate_retval  
 }  
30    
31  trap "" INT QUIT TSTP  trap "" INT QUIT TSTP
32    
# Line 94  trap "" INT QUIT TSTP Line 34  trap "" INT QUIT TSTP
34    
35  if [[ $runlevel = sysinit ]]  if [[ $runlevel = sysinit ]]
36  then  then
37   echo   rc_echo
38   echo -e "${COLGREEN}Starting ${COLBLUE}MAGELLAN (v${MAGEVER}) ${COLGREEN}Linux${COLDEFAULT}"   rc_echo -e "${COLGREEN}Starting ${COLBLUE}MAGELLAN (v${MAGEVER}) ${COLGREEN}Linux${COLDEFAULT}"
39   echo -e "Copyright 2001-2007 Niels Rogalla; http://magellan-linux.net"   rc_echo "Copyright 2001-2014 Niels Rogalla; http://magellan-linux.net"
40   echo   rc_echo
41    
42   # mount proc filesystem, needed for bootsplash;   # mount proc filesystem, needed for bootsplash;
43   # no use of '/etc/rc.d/init.d/mountproc' anymore   # no use of '/etc/rc.d/init.d/mountproc' anymore
44   if [ ! -e /proc/mounts ]   if [ ! -e /proc/mounts ]
45   then   then
46   echo -e ${COLOREDSTAR}"Mounting proc file system ..."   rc_print "Mounting proc file system ..."
47   mount -n /proc   mount -n /proc
48   evaluate_retval   evaluate_retval
49   fi   fi
# Line 112  then Line 52  then
52   [ -z "${RC_VERBOSE_LEVEL}" ] && RC_VERBOSE_LEVEL=3   [ -z "${RC_VERBOSE_LEVEL}" ] && RC_VERBOSE_LEVEL=3
53   echo "${RC_VERBOSE_LEVEL}" > /proc/sys/kernel/printk   echo "${RC_VERBOSE_LEVEL}" > /proc/sys/kernel/printk
54    
55   # mount sys file system before udev or devfs (kernel-2.6)   # mount sys file system before udev
56   if [[ $(kernel_major_version) = 2.6 ]]   if [ -d /sys ]
57   then   then
58   if [ -d /sys ]   if [ ! -e /sys/kernel/notes ]
59   then   then
60   echo -e ${COLOREDSTAR}"Mounting sysfs file system ..."   rc_print "Mounting sysfs file system ..."
61   mount -n -t sysfs sysfs /sys   mount -n -t sysfs sysfs /sys
62   evaluate_retval   evaluate_retval
  else  
  echo -e ${COLORED}"Fatal: mountpoint /sys missing ..."  
  echo -e ${COLYELLOW}"Please create the directory /sys (mkdir -p /sys)."  
  echo -e ${COLYELLOW}"It's essential for a 2.6 kernel."  
63   fi   fi
64     else
65     rc_echo -e ${COLRED}"Fatal: mountpoint /sys missing ..."
66     rc_echo -e ${COLYELLOW}"Please create the directory /sys (mkdir -p /sys)."
67     rc_echo -e ${COLYELLOW}"It's essential for a 2.6 kernel."
68   fi   fi
69    
70   ## load devfs ##   # start device management
71   # load devfs only with a 2.4 kernel or its really wanted with a 2.6   start_devicemanager
72   if [[ $(kernel_major_version) = 2.4 ]] || [[ ${RC_USED_DEV} = devfs ]]  
73     ## load devpts ##
74     # devfs/udev with 2.6 has no ptys, so devpts is also needed
75     # check if we really have devpts support
76     if kernel_supports_fs devpts
77   then   then
78   # start devfsd daemon, needed for bootsplash;   # /dev/pts maybe not exists.
79   # no use of '/etc/rc.d/init.d/devfs' anymore   # We only create this directory only if devfs was mounted,
80   # check if devfs was mounted by the kernel,   # or it will fail as / is still mounted readonly
81   # if not mount it (mbuild_livecd needs this one)   # udev has this dir already, only a sanity check for devfs
82   if [ ! -e /dev/.devfsd ]   if [ ! -d "/dev/pts" -a -e "/dev/.devfsd" ] && is_fs_mounted devfs
83   then   then
84   echo -e ${COLOREDSTAR}"Mounting devfs file system ..."   mkdir -p /dev/pts &> /dev/null || \
85   mount -n -t devfs devfs /dev   rc_echo "Could not create /dev/pts !"
  evaluate_retval  
86   fi   fi
87    
88   if [ -e /dev/.devfsd ]   # now mount devpts
89     if [ -d /dev/pts ]
90   then   then
91   echo -e ${COLOREDSTAR}"Starting devfsd ..."   rc_print "Mounting devpts at /dev/pts ..."
92   ## directory /lib/dev-state !must! exists ##   mount -n -t devpts -o gid=4,mode=0620 devpts /dev/pts
  /sbin/devfsd /dev &> /dev/null  
93   evaluate_retval   evaluate_retval
  else  
  echo -e ${COLRED}"No devfs filesystem found ..."  
  echo -e ${COLYELLOW}"Your Kernel doesn't support the devfs filesystem."  
  echo -e ${COLYELLOW}"Devfs is necessary to run Magellan-Linux."  
  echo -e ${COLYELLOW}"Please make shure that this is enabled in your kernel."  
  echo  
  echo -e ${COLYELLOW}"Press any key to shutdown the system safely ..."  
  read  
  $rc_base/init.d/halt  
94   fi   fi
95     else
96     # devpts is not supported, give a warning
97     rc_echo -e ${COLRED}"No devpts filesystem found ..."
98     rc_echo -e ${COLYELLOW}"Your Kernel doesn't support the devpts filesystem."
99     rc_echo -e ${COLYELLOW}"Devfs/Udev with a kernel-2.6.x needs devpts,"
100     rc_echo -e ${COLYELLOW}"or no pty's are available."
101     rc_echo -e ${COLYELLOW}"Please make sure that this is enabled in your kernel."
102     rc_echo
103     rc_echo -e ${COLYELLOW}"Press any key to continue ..."
104     read
105   fi   fi
106     ## end devpts ##
107    
  #### load udev ####  
  # load udev only with a 2.6 kernel  
  if [[ $(kernel_major_version) = 2.6 ]] && [[ ${RC_USED_DEV} = udev ]]  
  then  
  # check if /dev/console exists outside tmpfs  
  [ -c /dev/console ] ; need_redirect=$?  
108    
109   # create a ramdisk for populating udev   ## load usbfs ##
110   echo -e ${COLOREDSTAR}"Mounting udev at /dev ..."   if kernel_supports_fs usbfs
111   # many video drivers needed exec access   then
112   fstype=ramfs   rc_print "Mounting usbfs at /proc/bus/usb ..."
113   # tmpfs was suggested by Greg Kroah-Hartman   mount -n -t usbfs usbfs /proc/bus/usb
  kernel_supports_fs tmpfs && fstype=tmpfs  
  mount -n -t ${fstype} udev /dev -o exec,nosuid,mode=0755  
114   evaluate_retval   evaluate_retval
115     fi
116     ## end usbfs ##
117    
118   # if a device tarball exists load it and if it is activated   ## services state dir ##
119   echo -e ${COLOREDSTAR}"Configurating system to use udev ..."   rc_print "Mounting tmpfs at ${svcdir} ..."
120   if [[ ${RC_DEVICE_TARBALL} = yes ]]   mount -n -t tmpfs tmpfs "${svcdir}" -o rw,mode=0644,size="${svcsize}"k
121   then   evaluate_retval
  echo -e ${COLOREDSTAR}"  Populating /dev with saved device nodes ..."  
  tar -jxpf /lib/udev-state/devices.tar.bz2 -C /dev  
  evaluate_retval  
  fi  
   
  # other eeded device nodes with udev  
  seed_dev  
   
  if [ -e /proc/sys/kernel/hotplug ]  
  then  
  if [ "$(kernel_version | sed 's:\.::g' | cut -d_ -f1)" -gt "2614" ]  
  then  
  echo -e ${COLOREDSTAR}"  Using netlink for hotplug events ..."  
  echo "" > /proc/sys/kernel/hotplug  
  evaluate_retval  
  else  
  echo -e ${COLOREDSTAR}"  Setting /sbin/udevsend as hotplug agent ..."  
  echo "/sbin/udevsend" > /proc/sys/kernel/hotplug  
  evaluate_retval  
  fi  
  else  
  echo -e ${COLOREDSTAR}${COLYELLOW}"  Kernel was not compiled with hotplug support !"  
  print_status failure  
  fi  
122    
123   echo -e ${COLOREDSTAR}"  Starting udevd daemon ..."   ## /run /tmp /var/lock
124   if [ ${need_redirect} -eq 1 ]   for i in /run /tmp /var/lock
125     do
126     if [ -d ${i} ]
127   then   then
128   # we need to open fds 0 1 2   rc_print "Mounting tmpfs at ${i} ..."
129   /sbin/udevd --daemon </dev/console >/dev/console 2>/dev/console   mount -n -t tmpfs tmpfs ${i} -o rw,nosuid,nodev,relatime
130   else   evaluate_retval
  /sbin/udevd --daemon  
131   fi   fi
132     done
133     # extra check for /var/lock
134     if [ -L /var/lock ]
135     then
136     mkdir -p /run/lock
137     rc_print "Mounting tmpfs at /run/lock ..."
138     mount -n -t tmpfs tmpfs /run/lock -o rw,nosuid,nodev,relatime
139   evaluate_retval   evaluate_retval
   
  /lib/udev/write_root_link_rule  
  populate_udev  
   
  # create nodes that udev can't  
  echo -e ${COLOREDSTAR}"  Finializing udev configuration ..."  
  [[ -x /sbin/dmsetup ]] && /sbin/dmsetup mknodes &>/dev/null  
  [[ -x /sbin/lvm ]] && /sbin/lvm vgscan -P --mknodes --ignorelockingfailure &>/dev/null  
  [[ -x /sbin/evms_activate ]] && /sbin/evms_activate -q &>/dev/null  
  print_status success  
   
  # same thing as /dev/.devfsd  
  touch /dev/.udev  
140   fi   fi
141     # extra check if /run and /var/run are directories
142   ## load devpts ##   if [ -d /run ] && [ -d /var/run ]
  # devfs/udev with 2.6 has no ptys, so devpts is also needed  
  if [[ $(kernel_major_version) = 2.6 ]]  
143   then   then
144   # check if we really have devpts support   rc_print "Mounting tmpfs at /var/run ..."
145   if kernel_supports_fs devpts   mount -n -o bind /run /var/run
146   then   evaluate_retval
  # /dev/pts maybe not exists.  
  # We only create this directory only if devfs was mounted,  
  # or it will fail as / is still mounted readonly  
  # udev has this dir already, only a sanity check for devfs  
  if [ ! -d "/dev/pts" -a -e "/dev/.devfsd" ] && is_fs_mounted devfs  
  then  
  mkdir -p /dev/pts &> /dev/null || \  
  echo "Could not create /dev/pts !"  
  fi  
   
  # now mount devpts  
  if [ -d /dev/pts ]  
  then  
  echo -e ${COLOREDSTAR}"Mounting devpts at /dev/pts ..."  
  mount -n -t devpts -o gid=4,mode=0620 devpts /dev/pts  
  evaluate_retval  
  fi  
  else  
  # devpts is not supported, give a warning  
  echo -e ${COLRED}"No devpts filesystem found ..."  
  echo -e ${COLYELLOW}"Your Kernel doesn't support the devpts filesystem."  
  echo -e ${COLYELLOW}"Devfs with a kernel-2.6.x needs devpts,"  
  echo -e ${COLYELLOW}"or no pty's are available."  
  echo -e ${COLYELLOW}"Please make shure that this is enabled in your kernel."  
  echo  
  echo -e ${COLYELLOW}"Press any key to continue ..."  
  read  
  fi  
147   fi   fi
148    
  ### services state dir ###  
  echo -e ${COLOREDSTAR}"Mounting tmpfs at ${svcdir} ..."  
  mount -n -t tmpfs tmpfs "${svcdir}" -o rw,mode=0644,size="${svcsize}"k  
  evaluate_retval  
   
149   # load bootsplash   # load bootsplash
150   splash "rc_init" "${runlevel}"   splash "rc_init" "${runlevel}"
151  fi  fi
# Line 283  then Line 158  then
158    
159   # if requested save devices to a device tarball before halt   # if requested save devices to a device tarball before halt
160   # only for kernels >=2.6 *and* udev   # only for kernels >=2.6 *and* udev
161   # make shure that udev is mounted but *not* devfs --> /dev/.devfsd   # make sure that udev is mounted but *not* devfs --> /dev/.devfsd
162   if [[ ${RC_DEVICE_TARBALL} = yes ]] && \   if [[ ${RC_DEVICE_TARBALL} = yes ]] && \
163   [ -e /dev/.udev -a ! -e /dev/.devfsd -a ! -e /.bootdev ]   [ -e /dev/.udev -a ! -e /dev/.devfsd -a ! -e /.bootdev ]
164   then   then
165   echo -e ${COLOREDSTAR}"Saving /dev device nodes ..."   rc_print "Saving /dev device nodes ..."
166   ( cd /dev; tar -jclpf "/tmp/devices-$$.tar.bz2" * &> /dev/null )   ( cd /dev; tar -jclpf "/tmp/devices-$$.tar.bz2" * &> /dev/null )
167   mv -f "/tmp/devices-$$.tar.bz2" /lib/udev-state/devices.tar.bz2   mv -f "/tmp/devices-$$.tar.bz2" /lib/udev/state/devices.tar.bz2
168   evaluate_retval   evaluate_retval
169   fi   fi
170    
171     # stop device management
172     stop_devicemanager
173  fi  fi
174    
175    
176  if [ "$runlevel" = "" ]  if [ "$runlevel" = "" ]
177  then  then
178   echo "Usage: $0 <runlevel>" >&2   rc_echo "Usage: $0 <runlevel>" >&2
179   exit 1   exit 1
180  fi  fi
181    
# Line 307  previous=$PREVLEVEL Line 185  previous=$PREVLEVEL
185    
186  if [ ! -d $rc_base/rc$runlevel.d ]  if [ ! -d $rc_base/rc$runlevel.d ]
187  then  then
188   echo "$rc_base/rc$runlevel.d does not exist"   rc_echo "$rc_base/rc$runlevel.d does not exist"
189   exit 1   exit 1
190  fi  fi
191    
# Line 327  then Line 205  then
205   if [ ! -f $prev_start ] && [ ! -f $sysinit_start ]   if [ ! -f $prev_start ] && [ ! -f $sysinit_start ]
206   then   then
207   $WARNING   $WARNING
208   echo "$i can't be executed because it was"   rc_echo "$i can't be executed because it was"
209   echo "not started in the previous runlevel ($previous)"   rc_echo "not started in the previous runlevel ($previous)"
210   $NORMAL   $NORMAL
211   continue   continue
212   fi   fi

Legend:
Removed from v.514  
changed lines
  Added in v.2304